//plugin, ktery umozni zobrazit na mape body v GeoJSON souboru
//pokud je v properties nastaven trida 'LAB serie', do popup okna doplni
//odkaz na zakladni a podrobne informace o serii
//  inspirovano pluginem osmcz.ggm, ktery zobrazuje rozcestniky bez fotky

var LAYER_GeoJsonFile=null;

var GeoJsonFile_icon_point=L.icon({
  iconUrl: "plugin/GeoJsonFile/balloon-ellipsis-ping.png",
  iconSize: [16, 16],
  iconAnchor: [11, 13]  //souradnice od leveho horniho rohu
});

var GeoJsonFile_icon_multipoint=L.icon({
  iconUrl: "plugin/GeoJsonFile/balloon-ellipsis-green.png",
  iconSize: [16, 16],
  iconAnchor: [11, 13]  //souradnice od leveho horniho rohu
});

var GeoJsonFile_icon=L.icon({
  iconUrl: "plugin/GeoJsonFile/balloon-ellipsis.png",
  iconSize: [16, 16],
  iconAnchor: [11, 13]  //souradnice od leveho horniho rohu
});

function GeoJsonFileLoad(file) {
//aktivní vrstva se zobrazenymi body
  if(LAYER_GeoJsonFile!=null) LAYER_GeoJsonFile.clearLayers();
  LAYER_GeoJsonFile=null;
  LAYER_GeoJsonFile=L.geoJSON(null, {
        pointToLayer: function(feature, latlng){
          //nastavime svoji ikonu, tatoje pro MultiPoint, protoze pro Point
          //ji nastavujeme zvlast
          return L.marker(latlng, {icon: GeoJsonFile_icon_multipoint});
        },
        style: function (feature) {
            var color='#ff6600';
            var dash='5,10';
            if(feature.geometry.type=="Polygon"){ color='#0050ff'; dash='3,6';}
            if(feature.geometry.type=="LineString"){ color='#ff2030'; dash='8,4';}
            //projdeme vsechny vlastnosti, jestli tam neni nastavena barva nebo dash
            for(var prop in feature.properties){
              if(prop=="color") color=feature.properties[prop];
              if(prop=="dashArray") dash=feature.properties[prop];
            }
            return {
              color: color,
              stroke: true,
              weight: 2,
              opacity: 1,
              dashArray: dash
            }
        },
        onEachFeature: function (feature, layer) {
          var html_content='';
          var bClass=false;
          if(feature.geometry.type=="Point") layer.setIcon(GeoJsonFile_icon_point);
          for(var prop in feature.properties){
            //pro LAB serie nevypisujeme hodnotu class
            if(prop=="class") bClass=true;
            if((prop!='class' || feature.properties[prop]!='LAB serie')
              && prop!='color' && prop!='dashArray')
              html_content+=prop+': '+feature.properties[prop]+'<br/>';
          }
          if(html_content==''){
            html_content="type: "+feature.type+'<br/>';
            var bId=false;
            for(var prop in feature){
              if(prop=="id") bId=true;
            }
            if(bId) html_content="type: "+feature.id+'<br/>';
          }
          if(bClass && feature.properties.class=="LAB serie"){
              //layer.setIcon(GeoJsonFile_icon); //pokud nedam svoji ikonu, bude implicitni modry marker
              var url='https://labs-api.geocaching.com/Api/Adventures/';
              //linky na xml s prehledem a detaily o serii
              html_content+='<div class="cLabInfo">'
                +'<a href="'+url+'GetAdventureBasicInfo?id='+feature.id+'" target="_blank">Basic XML</a>'
                +'<a href="'+url+feature.id+'" target="_blank">Detail XML</a></div>';
          }
          //definice popup okna
          layer.bindPopup(html_content, {
              offset: new L.Point(0,-3),
              minWidth: 150,
              closeOnClick: false,
              autoPan: false,
              keepInView: true,
              autoPanPadding: new L.Point(5, 5),
              className:'cGjFilePopup' //[ridame svoji tridu, abychom mohli vzhled zmenit v CSS
          });
        }
    });
  map.addLayer(LAYER_GeoJsonFile);  //pridame a zobrazime vrstvu
  //nacteme soubor a priadame do vrstvy data
  var reader=new FileReader();
  reader.readAsText(file,'UTF-8'); //nacteme soubor (predpokladame v utf-8)
  var data='';
  reader.onload=readerEvent => {
    data=jQuery.parseJSON(readerEvent.target.result); //toto je nacteny obsah, parsovany jako JSON
    LAYER_GeoJsonFile.addData(data);
  }
};

/*
function GeoJsonFile_ggm_clear() {
  //vola se pri/po kazdem bbox, proto se ikony vykresli a hned zase zmizi
  LAYER_GeoJsonFile.clearLayers();
};
*/
/*
function GeoJsonFile_ggm_bbox(S, W, N, E, zoom) {
};
*/

function GeoJsonFile_add_form(){
	form='<div id="iGeoJsonForm" class="noprint leaflet-control-layers movable">'
      +'<img id="iGeoJsonLoad" title="Zobrazení GeoJSON souboru s body" alt="Zobrazení GeoJSON souboru s body" src="plugin/GeoJsonFile/geojson-24.png" />'
	    +'<div class="movable-corner"></div>'
	    +'</div>'
  $('#filter-panel').after(form); //vlozime div s ikonkou
 	//obsluha tlacitka Load GeoJson
	$("#iGeoJsonLoad").click(function(){
    var input=document.createElement('input');
    input.type='file';
    input.onchange = e => {
      GeoJsonFileLoad(e.target.files[0]);
    };
    input.click();
	});
}

function GeoJsonFile_ggm_init() {
	loadcss('plugin/GeoJsonFile.css');
	ggmregister('onmap', GeoJsonFile_add_form);
  //ggmregister('onclear', GeoJsonFile_ggm_clear);
  //ggmregister('loadbbox', GeoJsonFile_ggm_bbox);
}
